// ComputeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ThreadSimple.h"
#include "ComputeDlg.h"
#include ".\computedlg.h"

#define WM_THREADFINISHED WM_USER+11

int g_nCount = 0;
// CComputeDlg dialog

IMPLEMENT_DYNAMIC(CComputeDlg, CDialog)
CComputeDlg::CComputeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComputeDlg::IDD, pParent)
{
}

CComputeDlg::~CComputeDlg()
{
}

void CComputeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CComputeDlg, CDialog)
	ON_WM_TIMER()
	ON_MESSAGE(WM_THREADFINISHED, OnThreadFinished)
END_MESSAGE_MAP()


// CComputeDlg message handlers

UINT ComputeThreadProc(LPVOID param) {
	volatile int nTemp;
	for (g_nCount = 0; g_nCount < CComputeDlg::nMaxCount;
			::InterlockedIncrement((long*) &g_nCount)) 
	{
		for (nTemp = 0; nTemp < 10000; nTemp++) {
		}
	}
	::PostMessage((HWND) param, WM_THREADFINISHED, 0, 0);
	g_nCount = 0;
	return 0;
}


void CComputeDlg::OnTimer(UINT nIDEvent)
{
	CProgressCtrl *pBar = (CProgressCtrl*) GetDlgItem(IDC_PROGRESS1);
	pBar->SetPos(g_nCount * 100 / nMaxCount);
}

void CComputeDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class
	if (g_nCount == 0) {
		CDialog::OnCancel();
	} else {
		g_nCount = nMaxCount;
	}
}

void CComputeDlg::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class
	int nTimer = SetTimer(1, 100, NULL);
	ASSERT(nTimer != 0);
	((CButton*)GetDlgItem(IDOK))->EnableWindow(FALSE);
	AfxBeginThread(ComputeThreadProc, GetSafeHwnd(),
		THREAD_PRIORITY_NORMAL);	
}

LRESULT CComputeDlg::OnThreadFinished(WPARAM wParam, LPARAM lParam)
{
	CDialog::OnOK();
	return 0L;
}
