// ThreadSimpleView.h : interface of the CThreadSimpleView class
//


#pragma once

const WM_THREADENDED = WM_USER + 10;


class CThreadSimpleView : public CView
{
protected: // create from serialization only
	CThreadSimpleView();
	DECLARE_DYNCREATE(CThreadSimpleView)

// Attributes
public:
	CThreadSimpleDoc* GetDocument() const;

// Operations
public:

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// Implementation
public:
	virtual ~CThreadSimpleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnThreadStart();
	afx_msg void OnThreadEndthread();
	bool m_bThreadRunning;
	afx_msg void OnUpdateThreadStart(CCmdUI *pCmdUI);
	afx_msg void OnUpdateThreadEndthread(CCmdUI *pCmdUI);
	afx_msg LRESULT OnThreadEnded(WPARAM wParam, LPARAM lParam);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
};

#ifndef _DEBUG  // debug version in ThreadSimpleView.cpp
inline CThreadSimpleDoc* CThreadSimpleView::GetDocument() const
   { return reinterpret_cast<CThreadSimpleDoc*>(m_pDocument); }
#endif

